Texture2DArray texArray <string uiname="Texture Array";>;

SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
	AddressW = Wrap;
};
/* 
cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : VIEWPROJECTION;
};
*/
cbuffer cbPerObj : register(b0)
{
	float4x4 tVP : VIEWPROJECTION;
	float4x4 tW : WORLD;
	float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
	int zSlice <string uiname="Slice Z"; >;
};

struct vsInput
{
	//float4 pos : POSITION;
	float4 PosO : POSITION;
	float4 uv : TEXCOORD0;
};

struct psInput
{
    //float4 pos: SV_POSITION;
	float4 PosWVP: SV_POSITION;
    float4 uv: TEXCOORD0;
};

psInput VS(vsInput input)
{
	//return input;
	psInput output;
    output.PosWVP  = mul(input.PosO,mul(tW,tVP));
    output.uv = input.uv;
    return output;
}


float4 PS(psInput input): SV_Target
{
	float3 uvs = float3(input.uv.xy, zSlice);	
    float4 col = texArray.Sample(g_samLinear,uvs);
    //float4 col = texArray.Sample(g_samLinear,float3(input.uv.xy,zSlice)) * cAmb;
	col.a *= Alpha;
    return col;
}

technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




